8014: Remove unused sso-server-upgrade.sh script.
[arvados-dev.git] / jenkins / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 read -rd "\000" helpmessage <<EOF
6 $(basename $0): Install and test Arvados components.
7
8 Exit non-zero if any tests fail.
9
10 Syntax:
11         $(basename $0) WORKSPACE=/path/to/arvados [options]
12
13 Options:
14
15 --skip FOO     Do not test the FOO component.
16 --only FOO     Do not test anything except the FOO component.
17 --temp DIR     Install components and dependencies under DIR instead of
18                making a new temporary directory. Implies --leave-temp.
19 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
20                Instead, show the path to give as --temp to reuse them in
21                subsequent invocations.
22 --skip-install Do not run any install steps. Just run tests.
23                You should provide GOPATH, GEMHOME, and VENVDIR options
24                from a previous invocation if you use this option.
25 --only-install Run specific install step
26 WORKSPACE=path Arvados source tree to test.
27 CONFIGSRC=path Dir with api server config files to copy into source tree.
28                (If none given, leave config files alone in source tree.)
29 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
30                Restrict apiserver tests to the given file
31 sdk/python_test="--test-suite test.test_keep_locator"
32                Restrict Python SDK tests to the given class
33 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
34                Restrict Workbench tests to the given file
35 services/arv-git-httpd_test="-check.vv"
36                Show all log messages, even when tests pass (also works
37                with services/keepstore_test etc.)
38 ARVADOS_DEBUG=1
39                Print more debug messages
40 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
41                *_test, and other examples shown above.
42
43 Assuming --skip-install is not given, all components are installed
44 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
45 test suites depend on other components being installed, and installing
46 everything tends to be quicker than debugging dependencies.
47
48 As a special concession to the current CI server config, CONFIGSRC
49 defaults to $HOME/arvados-api-server if that directory exists.
50
51 More information and background:
52
53 https://arvados.org/projects/arvados/wiki/Running_tests
54
55 Available tests:
56
57 apps/workbench
58 apps/workbench_benchmark
59 apps/workbench_profile
60 doc
61 services/api
62 services/arv-git-httpd
63 services/crunchstat
64 services/dockercleaner
65 services/fuse
66 services/keep-web
67 services/keepproxy
68 services/keepstore
69 services/login-sync
70 services/nodemanager
71 sdk/cli
72 sdk/pam
73 sdk/python
74 sdk/ruby
75 sdk/go/arvadosclient
76 sdk/go/keepclient
77 sdk/go/manifest
78 sdk/go/blockdigest
79 sdk/go/streamer
80 sdk/go/crunchrunner
81 tools/crunchstat-summary
82 tools/keep-rsync
83
84 EOF
85
86 # First make sure to remove any ARVADOS_ variables from the calling
87 # environment that could interfere with the tests.
88 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
89
90 # Reset other variables that could affect our [tests'] behavior by
91 # accident.
92 GITDIR=
93 GOPATH=
94 VENVDIR=
95 VENV3DIR=
96 PYTHONPATH=
97 GEMHOME=
98 PERLINSTALLBASE=
99
100 COLUMNS=80
101
102 skip_install=
103 temp=
104 temp_preserve=
105
106 clear_temp() {
107     if [[ -z "$temp" ]]; then
108         # we didn't even get as far as making a temp dir
109         :
110     elif [[ -z "$temp_preserve" ]]; then
111         rm -rf "$temp"
112     else
113         echo "Leaving behind temp dirs in $temp"
114     fi
115 }
116
117 fatal() {
118     clear_temp
119     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
120     exit 1
121 }
122
123 report_outcomes() {
124     for x in "${successes[@]}"
125     do
126         echo "Pass: $x"
127     done
128
129     if [[ ${#failures[@]} == 0 ]]
130     then
131         echo "All test suites passed."
132     else
133         echo "Failures (${#failures[@]}):"
134         for x in "${failures[@]}"
135         do
136             echo "Fail: $x"
137         done
138     fi
139 }
140
141 exit_cleanly() {
142     trap - INT
143     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
144     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
145     stop_services
146     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
147     report_outcomes
148     clear_temp
149     exit ${#failures}
150 }
151
152 sanity_checks() {
153     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
154         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
155     echo Checking dependencies:
156     echo -n 'virtualenv: '
157     virtualenv --version \
158         || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
159     echo -n 'go: '
160     go version \
161         || fatal "No go binary. See http://golang.org/doc/install"
162     echo -n 'gcc: '
163     gcc --version | egrep ^gcc \
164         || fatal "No gcc. Try: apt-get install build-essential"
165     echo -n 'fuse.h: '
166     find /usr/include -wholename '*fuse/fuse.h' \
167         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
168     echo -n 'pyconfig.h: '
169     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
170         || fatal "No pyconfig.h. Try: apt-get install python-dev"
171     echo -n 'nginx: '
172     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
173         || fatal "No nginx. Try: apt-get install nginx"
174     echo -n 'perl: '
175     perl -v | grep version \
176         || fatal "No perl. Try: apt-get install perl"
177     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
178         echo -n "perl $mod: "
179         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
180             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
181     done
182     echo -n 'gitolite: '
183     which gitolite \
184         || fatal "No gitolite. Try: apt-get install gitolite3"
185 }
186
187 rotate_logfile() {
188   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
189   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
190   if [[ -f "$1/$2" ]]; then
191     THEDATE=`date +%Y%m%d%H%M%S`
192     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
193     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
194   fi
195 }
196
197 declare -a failures
198 declare -A skip
199 declare -A testargs
200 skip[apps/workbench_profile]=1
201
202 while [[ -n "$1" ]]
203 do
204     arg="$1"; shift
205     case "$arg" in
206         --help)
207             echo >&2 "$helpmessage"
208             echo >&2
209             exit 1
210             ;;
211         --skip)
212             skipwhat="$1"; shift
213             skip[$skipwhat]=1
214             ;;
215         --only)
216             only="$1"; skip[$1]=""; shift
217             ;;
218         --skip-install)
219             skip_install=1
220             ;;
221         --only-install)
222             skip_install=1
223             only_install="$1"; shift
224             ;;
225         --temp)
226             temp="$1"; shift
227             temp_preserve=1
228             ;;
229         --leave-temp)
230             temp_preserve=1
231             ;;
232         --retry)
233             retry=1
234             ;;
235         *_test=*)
236             suite="${arg%%_test=*}"
237             args="${arg#*=}"
238             testargs["$suite"]="$args"
239             ;;
240         *=*)
241             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
242             ;;
243         *)
244             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
245             exit 1
246             ;;
247     esac
248 done
249
250 start_api() {
251     echo 'Starting API server...'
252     cd "$WORKSPACE" \
253         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
254         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
255         && export ARVADOS_TEST_API_INSTALLED="$$" \
256         && (env | egrep ^ARVADOS)
257 }
258
259 start_nginx_proxy_services() {
260     echo 'Starting keepproxy, keep-web, arv-git-httpd, and nginx ssl proxy...'
261     cd "$WORKSPACE" \
262         && python sdk/python/tests/run_test_server.py start_keep_proxy \
263         && python sdk/python/tests/run_test_server.py start_keep-web \
264         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
265         && python sdk/python/tests/run_test_server.py start_nginx \
266         && export ARVADOS_TEST_PROXY_SERVICES=1
267 }
268
269 stop_services() {
270     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
271         unset ARVADOS_TEST_PROXY_SERVICES
272         cd "$WORKSPACE" \
273             && python sdk/python/tests/run_test_server.py stop_nginx \
274             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
275             && python sdk/python/tests/run_test_server.py stop_keep-web \
276             && python sdk/python/tests/run_test_server.py stop_keep_proxy
277     fi
278     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
279         unset ARVADOS_TEST_API_HOST
280         cd "$WORKSPACE" \
281             && python sdk/python/tests/run_test_server.py stop
282     fi
283 }
284
285 interrupt() {
286     failures+=("($(basename $0) interrupted)")
287     exit_cleanly
288 }
289 trap interrupt INT
290
291 sanity_checks
292
293 echo "WORKSPACE=$WORKSPACE"
294
295 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
296     # Jenkins expects us to use this by default.
297     CONFIGSRC="$HOME/arvados-api-server"
298 fi
299
300 # Clean up .pyc files that may exist in the workspace
301 cd "$WORKSPACE"
302 find -name '*.pyc' -delete
303
304 if [[ -z "$temp" ]]; then
305     temp="$(mktemp -d)"
306 fi
307
308 # Set up temporary install dirs (unless existing dirs were supplied)
309 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
310 do
311     if [[ -z "${!tmpdir}" ]]; then
312         eval "$tmpdir"="$temp/$tmpdir"
313     fi
314     if ! [[ -d "${!tmpdir}" ]]; then
315         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
316     fi
317 done
318
319 setup_ruby_environment() {
320     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
321       source "$HOME/.rvm/scripts/rvm"
322       using_rvm=true
323     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
324       source "/usr/local/rvm/scripts/rvm"
325       using_rvm=true
326     else
327       using_rvm=false
328     fi
329
330     if [[ "$using_rvm" == true ]]; then
331         # If rvm is in use, we can't just put separate "dependencies"
332         # and "gems-under-test" paths to GEM_PATH: passenger resets
333         # the environment to the "current gemset", which would lose
334         # our GEM_PATH and prevent our test suites from running ruby
335         # programs (for example, the Workbench test suite could not
336         # boot an API server or run arv). Instead, we have to make an
337         # rvm gemset and use it for everything.
338
339         [[ `type rvm | head -n1` == "rvm is a function" ]] \
340             || fatal 'rvm check'
341
342         # Put rvm's favorite path back in first place (overriding
343         # virtualenv, which just put itself there). Ignore rvm's
344         # complaint about not being in first place already.
345         rvm use @default 2>/dev/null
346
347         # Create (if needed) and switch to an @arvados-tests
348         # gemset. (Leave the choice of ruby to the caller.)
349         rvm use @arvados-tests --create \
350             || fatal 'rvm gemset setup'
351
352         rvm env
353     else
354         # When our "bundle install"s need to install new gems to
355         # satisfy dependencies, we want them to go where "gem install
356         # --user-install" would put them. (However, if the caller has
357         # already set GEM_HOME, we assume that's where dependencies
358         # should be installed, and we should leave it alone.)
359
360         if [ -z "$GEM_HOME" ]; then
361             user_gempath="$(gem env gempath)"
362             export GEM_HOME="${user_gempath%%:*}"
363         fi
364         PATH="$(gem env gemdir)/bin:$PATH"
365
366         # When we build and install our own gems, we install them in our
367         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
368         # PATH so integration tests prefer them over other versions that
369         # happen to be installed in $user_gempath, system dirs, etc.
370
371         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
372         PATH="$tmpdir_gem_home/bin:$PATH"
373         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
374
375         echo "Will install dependencies to $(gem env gemdir)"
376         echo "Will install arvados gems to $tmpdir_gem_home"
377         echo "Gem search path is GEM_PATH=$GEM_PATH"
378     fi
379 }
380
381 with_test_gemset() {
382     if [[ "$using_rvm" == true ]]; then
383         "$@"
384     else
385         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
386     fi
387 }
388
389 gem_uninstall_if_exists() {
390     if gem list "$1\$" | egrep '^\w'; then
391         gem uninstall --force --all --executables "$1"
392     fi
393 }
394
395 setup_virtualenv() {
396     local venvdest=$1; shift
397     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
398         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
399     fi
400     "$venvdest/bin/pip" install 'setuptools>=18' 'pip>=7'
401     # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
402     "$venvdest/bin/pip" install 'mock>=1.0' 'pbr<1.7.0'
403 }
404
405 export PERLINSTALLBASE
406 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
407
408 export GOPATH
409 mkdir -p "$GOPATH/src/git.curoverse.com"
410 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
411     || fatal "symlink failed"
412
413 setup_virtualenv "$VENVDIR" --python python2.7
414 . "$VENVDIR/bin/activate"
415
416 # Needed for run_test_server.py which is used by certain (non-Python) tests.
417 pip freeze 2>/dev/null | egrep ^PyYAML= \
418     || pip install PyYAML >/dev/null \
419     || fatal "pip install PyYAML failed"
420
421 # Preinstall forked version of libcloud, because nodemanager "pip install"
422 # won't pick it up by default.
423 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
424     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
425     || fatal "pip install apache-libcloud failed"
426
427 # Deactivate Python 2 virtualenv
428 deactivate
429
430 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
431 # Otherwise, skip dependent tests.
432 PYTHON3=$(which python3)
433 if [ "0" = "$?" ]; then
434     setup_virtualenv "$VENV3DIR" --python python3
435 else
436     PYTHON3=
437     skip[services/dockercleaner]=1
438     cat >&2 <<EOF
439
440 Warning: python3 could not be found
441 services/dockercleaner install and tests will be skipped
442
443 EOF
444 fi
445
446 # Reactivate Python 2 virtualenv
447 . "$VENVDIR/bin/activate"
448
449 # Note: this must be the last time we change PATH, otherwise rvm will
450 # whine a lot.
451 setup_ruby_environment
452
453 echo "PATH is $PATH"
454
455 if ! which bundler >/dev/null
456 then
457     gem install --user-install bundler || fatal 'Could not install bundler'
458 fi
459
460 checkexit() {
461     if [[ "$1" != "0" ]]; then
462         title "!!!!!! $2 FAILED !!!!!!"
463         failures+=("$2 (`timer`)")
464     else
465         successes+=("$2 (`timer`)")
466     fi
467 }
468
469 timer_reset() {
470     t0=$SECONDS
471 }
472
473 timer() {
474     echo -n "$(($SECONDS - $t0))s"
475 }
476
477 do_test() {
478     while ! do_test_once ${@} && [[ "$retry" == 1 ]]
479     do
480         read -p 'Try again? [Y/n] ' x
481         if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
482         then
483             break
484         fi
485     done
486 }
487
488 do_test_once() {
489     unset result
490     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
491     then
492         title "Running $1 tests"
493         timer_reset
494         if [[ "$2" == "go" ]]
495         then
496             covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
497             coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
498             # We do "go get -t" here to catch compilation errors
499             # before trying "go test". Otherwise, coverage-reporting
500             # mode makes Go show the wrong line numbers when reporting
501             # compilation errors.
502             if [[ -n "${testargs[$1]}" ]]
503             then
504                 # "go test -check.vv giturl" doesn't work, but this
505                 # does:
506                 cd "$WORKSPACE/$1" && \
507                     go get -t "git.curoverse.com/arvados.git/$1" && \
508                     go test ${coverflags[@]} ${testargs[$1]}
509             else
510                 # The above form gets verbose even when testargs is
511                 # empty, so use this form in such cases:
512                 go get -t "git.curoverse.com/arvados.git/$1" && \
513                     go test ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
514             fi
515             result="$?"
516             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
517             rm "$WORKSPACE/tmp/.$covername.tmp"
518         elif [[ "$2" == "pip" ]]
519         then
520             # $3 can name a path directory for us to use, including trailing
521             # slash; e.g., the bin/ subdirectory of a virtualenv.
522             cd "$WORKSPACE/$1" \
523                 && "${3}python" setup.py test ${testargs[$1]}
524         elif [[ "$2" != "" ]]
525         then
526             "test_$2"
527         else
528             "test_$1"
529         fi
530         result=${result:-$?}
531         checkexit $result "$1 tests"
532         title "End of $1 tests (`timer`)"
533         return $result
534     else
535         title "Skipping $1 tests"
536     fi
537 }
538
539 do_install() {
540     if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
541     then
542         title "Running $1 install"
543         timer_reset
544         if [[ "$2" == "go" ]]
545         then
546             go get -t "git.curoverse.com/arvados.git/$1"
547         elif [[ "$2" == "pip" ]]
548         then
549             # $3 can name a path directory for us to use, including trailing
550             # slash; e.g., the bin/ subdirectory of a virtualenv.
551
552             # Need to change to a different directory after creating
553             # the source dist package to avoid a pip bug.
554             # see https://arvados.org/issues/5766 for details.
555
556             # Also need to install twice, because if it believes the package is
557             # already installed, pip it won't install it.  So the first "pip
558             # install" ensures that the dependencies are met, the second "pip
559             # install" ensures that we've actually installed the local package
560             # we just built.
561             cd "$WORKSPACE/$1" \
562                 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
563                 && cd "$WORKSPACE" \
564                 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
565                 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
566         elif [[ "$2" != "" ]]
567         then
568             "install_$2"
569         else
570             "install_$1"
571         fi
572         checkexit $? "$1 install"
573         title "End of $1 install (`timer`)"
574     else
575         title "Skipping $1 install"
576     fi
577 }
578
579 title () {
580     txt="********** $1 **********"
581     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
582 }
583
584 bundle_install_trylocal() {
585     (
586         set -e
587         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
588         if ! bundle install --local --no-deployment; then
589             echo "(Running bundle install again, without --local.)"
590             bundle install --no-deployment
591         fi
592         bundle package --all
593     )
594 }
595
596 install_doc() {
597     cd "$WORKSPACE/doc" \
598         && bundle_install_trylocal \
599         && rm -rf .site
600 }
601 do_install doc
602
603 install_gem() {
604     gemname=$1
605     srcpath=$2
606     with_test_gemset gem_uninstall_if_exists "$gemname" \
607         && cd "$WORKSPACE/$srcpath" \
608         && bundle_install_trylocal \
609         && gem build "$gemname.gemspec" \
610         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
611 }
612
613 install_ruby_sdk() {
614     install_gem arvados sdk/ruby
615 }
616 do_install sdk/ruby ruby_sdk
617
618 install_perl_sdk() {
619     cd "$WORKSPACE/sdk/perl" \
620         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
621         && make install INSTALLDIRS=perl
622 }
623 do_install sdk/perl perl_sdk
624
625 install_cli() {
626     install_gem arvados-cli sdk/cli
627 }
628 do_install sdk/cli cli
629
630 install_login-sync() {
631     install_gem arvados-login-sync services/login-sync
632 }
633 do_install services/login-sync login-sync
634
635 # Install the Python SDK early. Various other test suites (like
636 # keepproxy) bring up run_test_server.py, which imports the arvados
637 # module. We can't actually *test* the Python SDK yet though, because
638 # its own test suite brings up some of those other programs (like
639 # keepproxy).
640 declare -a pythonstuff
641 pythonstuff=(
642     sdk/pam
643     sdk/python
644     services/fuse
645     services/nodemanager
646     tools/crunchstat-summary
647     )
648 for p in "${pythonstuff[@]}"
649 do
650     do_install "$p" pip
651 done
652 if [ -n "$PYTHON3" ]; then
653     do_install services/dockercleaner pip "$VENV3DIR/bin/"
654 fi
655
656 install_apiserver() {
657     cd "$WORKSPACE/services/api" \
658         && RAILS_ENV=test bundle_install_trylocal
659
660     rm -f config/environments/test.rb
661     cp config/environments/test.rb.example config/environments/test.rb
662
663     if [ -n "$CONFIGSRC" ]
664     then
665         for f in database.yml application.yml
666         do
667             cp "$CONFIGSRC/$f" config/ || fatal "$f"
668         done
669     fi
670
671     # Fill in a random secret_token and blob_signing_key for testing
672     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
673     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
674
675     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
676     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
677
678     # Set up empty git repo (for git tests)
679     GITDIR=$(mktemp -d)
680     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
681
682     rm -rf $GITDIR
683     mkdir -p $GITDIR/test
684     cd $GITDIR/test \
685         && git init \
686         && git config user.email "jenkins@ci.curoverse.com" \
687         && git config user.name "Jenkins, CI" \
688         && touch tmp \
689         && git add tmp \
690         && git commit -m 'initial commit'
691
692     # Clear out any lingering postgresql connections to the test
693     # database, so that we can drop it. This assumes the current user
694     # is a postgresql superuser.
695     cd "$WORKSPACE/services/api" \
696         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
697         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
698
699     cd "$WORKSPACE/services/api" \
700         && RAILS_ENV=test bundle exec rake db:drop \
701         && RAILS_ENV=test bundle exec rake db:setup \
702         && RAILS_ENV=test bundle exec rake db:fixtures:load
703 }
704 do_install services/api apiserver
705
706 declare -a gostuff
707 gostuff=(
708     sdk/go/arvadosclient
709     sdk/go/blockdigest
710     sdk/go/manifest
711     sdk/go/streamer
712     sdk/go/crunchrunner
713     services/arv-git-httpd
714     services/crunchstat
715     services/keep-web
716     services/keepstore
717     sdk/go/keepclient
718     services/keepproxy
719     services/datamanager/summary
720     services/datamanager/collection
721     services/datamanager/keep
722     services/datamanager
723     tools/keep-rsync
724     )
725 for g in "${gostuff[@]}"
726 do
727     do_install "$g" go
728 done
729
730 install_workbench() {
731     cd "$WORKSPACE/apps/workbench" \
732         && mkdir -p tmp/cache \
733         && RAILS_ENV=test bundle_install_trylocal
734 }
735 do_install apps/workbench workbench
736
737 test_doclinkchecker() {
738     (
739         set -e
740         cd "$WORKSPACE/doc"
741         ARVADOS_API_HOST=qr1hi.arvadosapi.com
742         # Make sure python-epydoc is installed or the next line won't
743         # do much good!
744         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
745     )
746 }
747 do_test doc doclinkchecker
748
749 stop_services
750
751 test_apiserver() {
752     cd "$WORKSPACE/services/api" \
753         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
754 }
755 do_test services/api apiserver
756
757 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
758 # because we don't need to start up the api server for subsequent tests.
759 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
760   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
761   exit_cleanly
762 fi
763
764 start_api
765
766 test_ruby_sdk() {
767     cd "$WORKSPACE/sdk/ruby" \
768         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
769 }
770 do_test sdk/ruby ruby_sdk
771
772 test_cli() {
773     cd "$WORKSPACE/sdk/cli" \
774         && mkdir -p /tmp/keep \
775         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
776 }
777 do_test sdk/cli cli
778
779 test_login-sync() {
780     cd "$WORKSPACE/services/login-sync" \
781         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
782 }
783 do_test services/login-sync login-sync
784
785 for p in "${pythonstuff[@]}"
786 do
787     do_test "$p" pip
788 done
789 do_test services/dockercleaner pip "$VENV3DIR/bin/"
790
791 for g in "${gostuff[@]}"
792 do
793     do_test "$g" go
794 done
795
796 test_workbench() {
797     start_nginx_proxy_services \
798         && cd "$WORKSPACE/apps/workbench" \
799         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
800 }
801 do_test apps/workbench workbench
802
803 test_workbench_benchmark() {
804     start_nginx_proxy_services \
805         && cd "$WORKSPACE/apps/workbench" \
806         && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
807 }
808 do_test apps/workbench_benchmark workbench_benchmark
809
810 test_workbench_profile() {
811     start_nginx_proxy_services \
812         && cd "$WORKSPACE/apps/workbench" \
813         && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
814 }
815 do_test apps/workbench_profile workbench_profile
816
817 exit_cleanly